
#include <LiquidCrystal.h>
#include <EEPROM.h>

#define Life     PB0 //?????
#define Fluxo    PD2 //?????
#define Nivel    PD6 //?????
#define Relay1   PD7

#define BUT1 A1     // Buton Minus
#define BUT2 A4     // Buton Plus
#define BUT3 A5     // Buton Meniu
#define Led_Back A3   // led de Led_Back

bool flag_bot1 = 0x00;
bool flag_bot2 = 0x00;
bool flag_bot3 = 0x00;

//adicionada
unsigned long timer32 = 0;

//variáveis 
unsigned long tim_tot_on = 0;    // hora em segundos
unsigned long tim_tot_of = 0;    // minutos em secundos
unsigned long actual = 0;
unsigned long inceput = 0;
unsigned long timpramas = 0;
unsigned long timpramas1 = 0;
unsigned long oreramase = 0;
unsigned long minuteramase = 0;
unsigned long secunderamase = 0;


bool ctr_on_off = 0;     //  a lampada e considerada desligada
byte minutos_on, horas_on, minutos_of, horas_of ;


byte Menu = 6; // obtêm valores da eeprom
byte minon;  // minuto on
byte oreon;  // hora   on
byte minoff; // minuto off
byte oreoff; // hora   off

byte segundos = 0;
byte minutos  = 0;
byte horas    = 0;




// -- Variabile pentru butoane --------
int buttonstate = 0;    //flag to see if the button has been pressed, used internal on the subroutine only
int pushlengthset = 2000;   // value for a long push in mS
int pushlength = pushlengthset;   // set default pushlength
int pushstart = 0;  // sets default push value for the button going low
int pushstop = 0;   // sets the default value for when the button goes back high

boolean buttonflag = false; // default value for the button flag

unsigned long intraremeniu;
unsigned long iesiremeniu = 60000; // timp revenire meniu initial daca nu se apasa buton meniu

int ultimaapasare;     // se memoreaza timpul cand se apasa ultima data butonul
int timplumina   = 10;   // timp cat ramane LED-ul de Led_Back ctr_on_off
byte Backmini = 35;
byte Backmaxi = 255;
byte nivelBack = 35;
byte treaptanivel = 7;  // treapta scadere iluminare d ela maxim la minim
byte EE0;


int        count_T2  = 0x00;                              //contador auxiliar para temporização
bool       timeout   = 0x00;
bool       disp_up   = 0x00;
bool       flag_r    = 0x00;

//---- Definire pini pentru conectare LCD ----//
LiquidCrystal lcd(A0,  //RS no digital 7
                  13,  //EN no digital 6
                  12,  //D4 no digital 5
                  11,  //D5 no digital 4
                  10,  //D6 no digital 3
                  9);  //D7 no digital 2

// prototipos de Funcoes

void Counter_on();
void Counter_off();
void Inicio();
void Menu_01();  // configura Minuto on do  Canal 1
void Menu_02();  // configura Hora   on do  Canal 1
void Menu_03(); //  configura Minuto off do Canal 1
void Menu_04(); //  configura Hora   off do Canal 1
void MenuAv() ; //  menu de aviso
void Atl_var(); //  atualiza as váriaveis programa
void Backlight();
int getpushlength ();


// --- Interrupção ---
ISR(TIMER2_OVF_vect){
  //Opção a rotina de tempo usando recarga do timer 2
  //Obtém tempo de 1 segundo baseado na rotina de acúmulo de erros
  //                          1SEG       PRESC   8BITS   XTAL
  //Valor a somar           1000000   *  1024  *  256 / 16000000  = 16384
  timer32+=16384;     //cada interrupção ocorre a cada 16384 us
  if(timer32>=1000000){//se chegou a 1 segundo  
    timer32= timer32 - 1000000;   
    actual += 1;

  /*   ?????  por enquanto sem uso
    segundos +=1;
    if (segundos > 59){
       segundos = 0;
      minutos+=1;
    }
    if (minutos > 59){
      minutos = 0;
      horas +=1;
    }
    if (horas > 23)
       horas = 0;
    */

       
    disp_up = 0x01;
    
  }// if(timer32>=1000000)
} //end ISR





/*
// --- Interrupção ---
 //erro de aprox. 2 minutos e 12 segundos em 24 horas ocasionado por este tipo de rotina !!!!!!
ISR(TIMER2_OVF_vect)
{
  TCNT2 = 100;                 //Reinicializa o registrador do Timer2
  count_T2++;                  //Incrementa count_T2

  // -- Base de Tempo de 1 Segundo --
  if (count_T2 == 100) //count_T2 igual a 100?
  { //Sim...          
    actual += 1;
    segundos +=1;
    if (segundos > 59){
       segundos = 0;
      minutos+=1;
    }
    if (minutos > 59){
      minutos = 0;
      horas +=1;
    }
    if (horas > 23)
       horas = 0;
    disp_up = 0x01;
    count_T2 = 0x00;              //Reinicia
  } //end if count_T2
} //end ISR

*/
//------------------------------------------------------------------------

void setup() {

  
  lcd.begin(16, 2);
  Serial.begin(9600);
  pinMode(Relay1, OUTPUT);  
  digitalWrite(Relay1, LOW);  

  pinMode(Led_Back, OUTPUT); 
  analogWrite(Led_Back, Backmaxi);
  pinMode(BUT1, INPUT_PULLUP);
  pinMode(BUT2, INPUT_PULLUP);
  pinMode(BUT3, INPUT_PULLUP);
  pinMode(Nivel, INPUT_PULLUP);
  pinMode(Fluxo, INPUT_PULLUP);
  TCCR2A = 0x00;                   //Timer operando em modo normal
  TCCR2B = 0x07;                   //Prescaler 1:1024
  TCNT2  = 0;                      //Inicializa TCNT2 com 0
  lcd.setCursor(0, 0);

  /* Nome do aparelho, versão do software e créditos aos autores
      lcd.setCursor(0, 1);
      lcd.print(" 2 Canale ON-OFF");
      delay(3000);
      lcd.clear();

      lcd.setCursor(0, 0);
      lcd.print(" Versiunea V 1.3");

      lcd.setCursor(0, 1);
      lcd.print(" GeoMar & Niq_ro");
  */
  //   delay(3000);
  analogWrite(Led_Back, Backmini);  // se aprinde lumina de Led_Back la minim
  lcd.clear();
  TIMSK2 = 0x01;                                        //Habilita interrupção do Timer2     
} // sfarsit program ce ruleaza la inceput si dupa resetare

void loop() {
   if(flag_r){
    Menu = 6;
    flag_r=0;    
  }
  if (Menu > 6)
  {
    lcd.clear();
    Menu = 6; 
  }
  switch (Menu) {
    case 0:
      Inicio();
      break;
    case 1:
      Menu_01();
      break;
    case 2:
      Menu_02();
      break;
    case 3 :
      Menu_03();
    case 4 :
      Menu_04();
    case 5:
      MenuAv();
      break;
    case 6:
      Atl_var();
      break;
  }
 
}

//------------------------------------------------------------------------------

void Inicio() {
  // actual = millis() / 1000; // forma anterior sem timer2    
   

   
   Backlight();
  if ((actual - inceput < tim_tot_on)  and (!ctr_on_off))
  {
    ctr_on_off = 0x1;
    digitalWrite(Relay1, HIGH);   // a l�mpada deve estar ligada
    disp_up = 0x01;
    lcd.clear();
  }

  if ((actual - tim_tot_on - inceput > 0) and (actual - tim_tot_on - inceput < tim_tot_of) and (ctr_on_off)) // daca becul e intervalul cand e stins
  { ctr_on_off = 0x0;
    digitalWrite(Relay1, LOW);   // becul sa fie stins
    disp_up = 0x01;
    lcd.clear();
  }
  //                     minutos on    minutos off
  if (((actual - inceput - tim_tot_on) >= tim_tot_of) and (!ctr_on_off)) {
    inceput = actual;
  }
  pushlength = pushlengthset;
  pushlength = getpushlength ();
  delay (10);

  if (pushlength > pushlengthset)
  {
    lcd.clear();
  //  lcd.setCursor(0, 0);
    lcd.print("- Wait. Please -");
    lcd.setCursor(0, 1);
    lcd.print("- Loading Menu -");
    delay(1000);
    digitalWrite(Relay1, LOW);
    Menu = 1;
    intraremeniu = millis(); //resolve bug de não entrar em modo de ajuste
  }
  else  if ((pushlength < pushlengthset) || (!digitalRead(BUT1)) || (!digitalRead(BUT2)))
  {
    pushlength = pushlengthset;
    Menu = 5;
  }
  // -------------------------------------
  // Monitora o tempo Desligado
  if (ctr_on_off == 0)
    Counter_off();
  // ----------------------------
  // Monitora o tempo Ligado
  if (ctr_on_off == 1)
    Counter_on();
}
//----------------------------------------------------
void Counter_on() {
  //  timpramas = tim_tot_of - actual + inceput + tim_tot_on; // enchendo linguiça 
  timpramas = tim_tot_on - actual + inceput;  // soma as horas em on
  oreramase = timpramas / 3600; // aqui mostra a hora
  timpramas1 = timpramas - 3600 * oreramase;
  minuteramase = timpramas1 / 60;
  secunderamase = timpramas1 - 60 * minuteramase;
  if (disp_up) { 
    Serial.println("");
    Serial.print(timpramas);
    lcd.setCursor(0, 0);
    lcd.print(" ON < Timer  OFF");
    lcd.setCursor(0, 1);
    if (oreramase < 10)
      lcd.print("0");
    lcd.print(oreramase);
    lcd.print(":");
    if (minuteramase < 10)
      lcd.print("0");
    lcd.print(minuteramase);
    lcd.print(":");
    if (secunderamase < 10)
      lcd.print("0");
      lcd.print(secunderamase);   
    // Mostra o contador de tempo OFF
    lcd.setCursor(11, 1);
    if (oreoff < 10)
      lcd.print("0");
    lcd.print(oreoff);
    lcd.print(":");
    if (minoff < 10)
      lcd.print("0");
    lcd.print(minoff);
    lcd.print(" ");
    disp_up = 0x00;
  }
}

//--------------------------------------------------------------------
void Counter_off() {
  timpramas = tim_tot_of - actual + inceput + tim_tot_on;
  // timpramas = tim_tot_of - actual + inceput;  
  oreramase = timpramas / 3600;
  timpramas1 = timpramas - 3600 * oreramase;
  minuteramase = timpramas1 / 60;
  secunderamase = timpramas1 - 60 * minuteramase;
  if (disp_up) {
    Serial.println("");
    Serial.print(timpramas);
    lcd.setCursor(0, 0);
    lcd.print(" ON  Timer > OFF");
    //--------------------------------
    lcd.setCursor(8, 1);
    if (oreramase < 10)
      lcd.print("0");
    lcd.print(oreramase);
    lcd.print(":");
    if (minuteramase < 10)
      lcd.print("0");
    lcd.print(minuteramase);
    lcd.print(":");
    if (secunderamase < 10)
      lcd.print("0");
    lcd.print(secunderamase);
    //
    // Mostra o tempo do Contador ON
    lcd.setCursor(0, 1);
    if (oreon < 10)
      lcd.print("0");
    lcd.print(oreon);
    lcd.print(":");
    if (minon < 10)
      lcd.print("0");
    lcd.print(minon);
    lcd.print(" ");
    disp_up = 0x00;
  }
}

//-----------------------------------------------------------------
void Menu_01() {
  lcd.clear();
  while (Menu == 1) {
    if (millis() - intraremeniu > iesiremeniu)
    {
      lcd.clear();
    //  lcd.setCursor(0, 0);
      lcd.print ("Get Out Menu SET");
      delay(1500);
      Menu = 6;     
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print("Set Canal 1-1");
    lcd.setCursor(0, 1);
    lcd.print("Set Min ON = ");
    if (minon < 10)
      lcd.print("0");
    lcd.print(minon);
    lcd.print(" ");

    if ((!digitalRead(BUT1)) and minon > 0 and !flag_bot1)
      flag_bot1 = 0x01;
    if (digitalRead(BUT1)  and flag_bot1) {
      flag_bot1 = 0x00;
      minon --;
      if (minon < 0)
        minon = 0;
    }
    //
    if ((!digitalRead(BUT2)) and (minon <= 59) and !flag_bot2)
      flag_bot2 = 0x01;
    if (digitalRead(BUT2) and flag_bot2) {
      flag_bot2 = 0x00;
      minon ++;
      if (minon > 59)
        minon = 0;
      delay(250);
    }
    //
    if (!digitalRead(BUT3) and !flag_bot3)
      flag_bot3 = 0x01;
    if (digitalRead(BUT3) && flag_bot3) {
      flag_bot3 = 0x00;
      if (minon > 59)
        minon  = 0;
      cli();
      EEPROM.write(1, minon);
      sei();
      intraremeniu = millis();
      Menu = 2;
      delay(250);
      lcd.clear();
    }
  }
}
// --------------------------------

void Menu_02() {
  while (Menu == 2) {
    if (millis() - intraremeniu > iesiremeniu)
    {
      lcd.clear();
    //  lcd.setCursor(0, 0);
      lcd.print ("Get Out Menu SET");
      delay(1500);
      Menu = 6;      
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print("Set Canal 1-2");
    lcd.setCursor(0, 1);
    lcd.print("Set Hrs ON = ");
    if (oreon < 10)
      lcd.print("0");
    lcd.print(oreon);
    lcd.print(" ");

    if (!digitalRead(BUT1) and oreon > 0 and !flag_bot1)
      flag_bot1 = 0x01;
    if (digitalRead(BUT1) && flag_bot1) {
      flag_bot1 = 0x00;
      oreon --;
      if (oreon < 0)
        oreon = 0;
    }
    if (!digitalRead(BUT2) and oreon <= 23 and !flag_bot2)// estava oreon <= 5
      flag_bot2 = 0x01;
    if (digitalRead(BUT2) and flag_bot2) {
      flag_bot2 = 0x00;
      oreon ++;
      if (oreon > 23) //estava oreon > 5
        oreon = 0;
    }

    if (!digitalRead(BUT3) && !flag_bot3)
      flag_bot3 = 0x01;
    if (digitalRead(BUT3) && flag_bot3) {
      flag_bot3 = 0x00;
      if (oreon > 23)//estava (oreon > 5)
        oreon = 0;
      cli();
      EEPROM.write(2, oreon);
      sei();
      intraremeniu = millis();
      Menu = 3;
      delay(200);
      lcd.clear();
    }
  }
}

//----------------------------------
void Menu_03() {
  while (Menu == 3) {
    if (millis() - intraremeniu > iesiremeniu)
    {
      lcd.clear();
    //  lcd.setCursor(0, 0);
      lcd.print ("Get Out Menu SET");
      delay(1500);
      Menu = 6;      
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print(" Set Canal 1-3");
    lcd.setCursor(0, 1);
    lcd.print("Set Min OFF = ");
    if (minoff < 10)
      lcd.print("0");
    lcd.print(minoff);
    lcd.print(" ");

    if (!digitalRead(BUT1) and minoff > 0 && !flag_bot1)
      flag_bot1 = 0x01;
    if (digitalRead(BUT1) && flag_bot1) {
      flag_bot1 = 0x00;
      minoff --;
      if (minoff < 0)
        minoff = 0;
      delay(200);
    }
    //
    if ((!digitalRead(BUT2)) and (minoff <= 59) && !flag_bot2)
      flag_bot2 = 0x01;

    if (digitalRead(BUT2) && flag_bot2) {
      flag_bot2 = 0x00;
      minoff ++;
      if (minoff > 59)
        minoff = 0;
    }
    //
    if (!digitalRead(BUT3) && !flag_bot3)
      flag_bot3 = 0x01;
    if (digitalRead(BUT3) && flag_bot3) {
      flag_bot3 = 0x00;
      if (minoff > 59)
        minoff = 0;
      cli();
      EEPROM.write(3, minoff);
      sei();
      intraremeniu = millis();
      Menu = 4;
      lcd.clear();
    }
  }
}
// --------------------------------------------

void Menu_04() {
  while (Menu == 4) {
    if (millis() - intraremeniu > iesiremeniu)
    {
      lcd.clear();
   //   lcd.setCursor(0, 0);
      lcd.print ("Get Out Menu SET");
      delay(1500);
      Menu = 6;      
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print(" Set Canal 1-4");
    lcd.setCursor(0, 1);
    lcd.print("Set Hrs OFF = ");
    if (oreoff < 10)
      lcd.print("0");
    lcd.print(oreoff);
    lcd.print(" ");

    if ((!digitalRead(BUT1)) and (oreoff > 0) && !flag_bot1)
      flag_bot1 = 0x01;

    if (digitalRead(BUT1) && flag_bot1)
    {
      flag_bot1 = 0x00;
      oreoff --;
      if (oreoff < 0 )
        oreoff = 0;
    }
    if ((!digitalRead(BUT2)) and (oreoff <= 23) && !flag_bot2) //estava (oreoff <= 5)
      flag_bot2 = 0x01;
      
    if (digitalRead(BUT2) && flag_bot2) {
      flag_bot2 = 0x00;
      oreoff ++;
      if (oreoff > 23)//estava if (oreoff > 5)
        oreoff = 0;
    }
    
    if (!digitalRead(BUT3) && !flag_bot3)
      flag_bot3 = 0x01;
      
    if (digitalRead(BUT3) && flag_bot3) {
      flag_bot3 = 0x00;
      if (oreoff > 23)//estava if (oreoff > 5)
        oreoff = 0;
      cli();
      EEPROM.write(4, oreoff);
      sei();     
      delay(200);
      // aqui botei pra não ir pra o set 2-1
      lcd.clear();
     // lcd.setCursor(0, 0);
      lcd.print(" Exit Set Menu");
      lcd.setCursor(0, 1);
      lcd.print("-Save Settings-");
      delay(1000);
      Menu = 6;
      flag_r=1; //vai atualizar display   
      actual = 0;
      lcd.clear();
      intraremeniu = millis();    
      
      // fim de adicionamento
    }
  }
}

//------------------------------------------------------------------------------

void Atl_var() {
  cli();  
  minon =  EEPROM.read(1);
  oreon =  EEPROM.read(2);
  minoff = EEPROM.read(3);
  oreoff = EEPROM.read(4);
  sei();
  
  minutos_on  = minon;  // minuto on na eeprom
  horas_on    = oreon;  // hora   on na eeprom
  minutos_of  = minoff; // minuto of na eeprom
  horas_of    = oreoff; // hora   of na eeprom
  
  // aqui transforma tudo em segundos  
  tim_tot_on  = (long)  3600 * horas_on  + 60 * minutos_on ; // Tempo em Segundos ligado  
  tim_tot_of  = (long)  3600 * horas_of  + 60 * minutos_of ;  // Tempo em Segundos desligado
  
  Serial.println("");
  Serial.print("tim_tot_on  ");
  Serial.print(tim_tot_on);
  Serial.print("   tim_tot_of  ");
  Serial.print(tim_tot_of);
  ctr_on_off = 0x00;
  Menu = 0;  
  delay(250);
  lcd.clear();
}


// menu de aviso

void MenuAv() {
  flag_bot1 = 0x00;
  flag_bot2 = 0x00;
  flag_bot3 = 0x00;
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" Press For 4 seg");
  lcd.setCursor(0, 1);
  lcd.print("Settings Button");
  delay(1000);
  lcd.clear();
  Menu = 0;
}

//------------------------------------------------------------------------------

void Backlight() {
  if ((!digitalRead(BUT3)) or (!digitalRead(BUT2)) or (!digitalRead(BUT1)))
  {
    analogWrite(Led_Back, Backmaxi);  // se aprinde la maxim fundalul
    delay(50);
    nivelBack = Backmaxi;
    ultimaapasare = millis() / 1000; // se memoreaza timpul cand s-a apasat ultima data butonul
  }
  if ((actual - ultimaapasare > timplumina) &&  (nivelBack > Backmini))  // daca a trecut timpul de aprindere lumina Led_Back la maxim si nu s-a stins la minim
  {
    nivelBack = nivelBack - treaptanivel;   // nivel aprindere in scadere
    if (nivelBack < Backmini) 
	    nivelBack = Backmini; // nu trebuie sa scada valaorea sub minim
    analogWrite(Led_Back, nivelBack);
  }
}
//------------------------------------------------------------------------------

int getpushlength () {
  buttonstate = digitalRead(BUT3);
  if (buttonstate == LOW && !buttonflag) {
    pushstart = millis();
    buttonflag = true;
  };

  if (buttonstate == HIGH && buttonflag) {
    pushstop = millis ();
    pushlength = pushstop - pushstart;
    buttonflag = false;
  };
  return pushlength;
}

// -------------------------------------------------------------------------- //
